/*
QVanaClock -- Vana'diel Clock for Zaurus SL-C Series.
Copyright (C) 2004 Gussan(http://sourceforge.jp/users/gsn/)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

#include <qpe/qpeapplication.h>
#include <qpe/qcopenvelope_qws.h>
#include <qcstring.h>
#include <qmainwindow.h>
#include <qtabwidget.h>
#include <qtimer.h>
#include <qevent.h>
#include "qvsclock.h"
#include "qvstimer.h"
#include "qvsship.h"
#include "qvsguild.h"
#include "qvssaverctl.h"

#ifndef QVSBASE_H
#define QVSBASE_H

class QVSMainWindow : public QMainWindow
{
    Q_OBJECT
  private:
    QTimer* m_pTimer;
    QVSClock* m_pClock;
    QTabWidget* m_pTab;
    QVSTimerWindow* m_pTimerWin;
    QVSShipTimeTableFromJ* m_pShipTableFromJ;
    QVSShipTimeTableToJ*   m_pShipTableToJ;
    QVSGuild* m_pGuild;
    int m_focusFlg;

    QTimer* m_pSaverTimer;
    QVSScreenSaverCtl* m_pSaverCtl;
  public:
    QVSMainWindow();
    void closeEvent(QCloseEvent *e);
    void resizeEvent(QResizeEvent *e);
  public slots:
    void handleRefresh();
    void handleTabChanged(QWidget *);
};

#endif //QVSBASE_H
